#if 0
import os
import itertools
from ctypes import *


def entry(s1, s2):
    if not os.path.exists("libtemp.so"):
        # ensure the correct filename, as this is a C library
        os.replace(__file__, "library.c")
        os.system("gcc -I/usr/include/python3.9 -shared -o libtemp.so -fPIC library.c")
    libtemp = CDLL("./libtemp.so")

    if all(c == " " for c in s1 + s2):
        return True
    for i, j in itertools.product(range(len(s1)), range(len(s2))):
        if s1[i] != " " and s1[i].lower() == s2[j].lower():
            break
    else:
        return False

    return bool(libtemp.entry((s1[:i] + s1[i+1:]).encode(), (s2[:j] + s2[j+1:]).encode()))

""" "
#endif

#define PY_SSIZE_T_CLEAN
#include <Python.h>
#include <stdio.h>
#include <sys/wait.h>

int allgood = 0;

int entry(char *s1, char *s2) {
    if (!allgood) {
        if (access("program", F_OK) && !fork()) {
            // ensure the correct filename, as this is a C program
            rename(__FILE__, "program.c");
            execlp("gcc", "gcc", "-I/usr/include/python3.9", "-lpython3.9", "program.c", "-o", "program", (char*) NULL);
        }
        wait(NULL);
        int status;
        if (!fork()) execl("./program", s1, s2, (char*) NULL);
        wait(&status);
        return WEXITSTATUS(status);
    }

    int l1 = strlen(s1);
    int l2 = strlen(s2);

    for (int i = 0; i < l1; i++)
        if (s1[i] != ' ')
            goto find_pair;
    for (int i = 0; i < l2; i++)
        if (s2[i] != ' ')
            goto find_pair;
    return 1;

    find_pair:
    for (int i = 0; i < l1; i++)
        for (int j = 0; j < l2; j++) {
            if (s1[i] != ' ' && !(abs(s1[i] - s2[j]) % 32)) {
                s1[i] = ' ';
                s2[j] = ' ';
                goto recurse;
            }
        }
    return 0;

    recurse:
    Py_Initialize();
    PyObject *sysmodule = PyImport_ImportModule("sys");
    PyObject *syspath = PyObject_GetAttrString(sysmodule, "path");
    PyList_Append(syspath, PyUnicode_FromString("."));
    Py_DECREF(syspath);
    Py_DECREF(sysmodule);

    // ensure the correct filename, as this is a Python library
    rename(__FILE__, "library.py");
    rename("library.c", "library.py");

    PyObject *module = PyImport_ImportModule("library");
    PyObject *entry = PyObject_GetAttrString(module, "entry");
    Py_DECREF(module);
    PyObject *result = PyObject_CallFunction(entry, "ss", s1, s2);
    Py_DECREF(entry);

    long r = PyLong_AsLong(result);
    Py_Finalize();
    return r;
}

int main(int argc, char **argv) {
    allgood = 1;
    return entry(argv[0], argv[1]);
}

#if 0
" """
#endif
